/*
 * File: main.c
 * Date: 15.04.2011
 * Denis Zheleznjakov http://ziblog.ru
 */

#ifndef MAIN_H_
#define MAIN_H_

#include <stdint.h>

#include "stm32f100rb.h"
#include "core_cm3.h"

#include "macros.h"

#include "stm32f10x_adc.h"
#include "stm32f10x_bkp.h"
#include "stm32f10x_can.h"
#include "stm32f10x_crc.h"
#include "stm32f10x_dac.h"
#include "stm32f10x_dbgmcu.h"
#include "stm32f10x_dma.h"
#include "stm32f10x_exti.h"
#include "stm32f10x_flash.h"
#include "stm32f10x_fsmc.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_i2c.h"
#include "stm32f10x_iwdg.h"
#include "stm32f10x_pwr.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_rtc.h"
#include "stm32f10x_sdio.h"
#include "stm32f10x_spi.h"
#include "stm32f10x_tim.h"
#include "stm32f10x_usart.h"
#include "stm32f10x_wwdg.h"
#include "misc.h"  // High level functions for NVIC and SysTick (add-on to CMSIS functions)

#include "interrupt.h"

#include "mcu_gpio.h"
#include "mcu_usart.h"
#include "mcu_gpio.h"

#define DAC1_OUTPUT	A, 4, HIGH, INPUT_FLOATING,
#define DAC2_OUTPUT	A, 5, HIGH, INPUT_FLOATING,

#define PIN_TEST	A, 5, HIGH, GENERAL_OUTPUT_PUSH_PULL, SPEED_50MHZ

extern void change_sinus(void);

#endif /* MAIN_H_ */
