/*
 * File: mcu_usart.h
 * Date: 18.04.2011
 * Denis Zheleznjakov http://ziblog.ru
 */

#ifndef MCU_USART_H_
#define MCU_USART_H_

#include "main.h"

#define USART_TX_BUFFER_SIZE    16 // кратен двум
#define USART_RX_BUFFER_SIZE    16 // кратен двум

enum usart_fifo_error
{
    USART_FIFO_ERROR_FRAME = BIT(0),
    USART_FIFO_ERROR_OVERRUN = BIT(1),
    USART_FIFO_ERROR_NOISE = BIT(2),
    USART_FIFO_ERROR_BUFFER_OVERFLOW = BIT(3),
    USART_FIFO_NO_DATA = BIT(4)
};

void mcu_usart1_init(uint32_t baud_rate);
void mcu_usart1_fifo_transmit(uint8_t data);
uint8_t mcu_usart1_fifo_receive(uint8_t * data);
void handler_usart1_tx(void);
void handler_usart1_rx(void);

#endif /* MCU_USART_H_ */
